<?php

//Require the ZenCart Application 
require('includes/application_top.php');
//include the Quickbooks Functions
require('quickbooksSync/qbClass.php');

//Turn on Error Reporting (only for Debugging) 
 //E_ALL for Debug, 0 for Production

ini_set('error_reporting', E_ALL);


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#DO NOT EDIT BELOW THIS LINE
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


$qb = new Quickbooks();

//Authenticate the User based on the Zen Cart Admin Users All Admin Users are Valid for Quickbooks
function authenticate($params){
	global $db;//Zends Database Object
	global $settings;//Our Settings
	global $qb;//The Quickbooks Object

	//Set the QB Ticket
	 	$result['authenticateResult'][0] = md5(time() . $params->strUserName);
		$settings->ticket = $result['authenticateResult'][0]; 
	//Select the User Details from the Database
		$sql = "select admin_id, admin_name, admin_pass from " . TABLE_ADMIN . " where admin_name = '" . zen_db_input($params->strUserName) . "'";
    	$dbresult = $db->Execute($sql);
	//Validate User
 	   	if (!($params->strUserName == $dbresult->fields['admin_name'])) {
	       	$result['authenticateResult'][1] = 'nvu';
    		return $result; //Die Not a Valid User 
	    }elseif (!zen_validate_password($params->strPassword, $dbresult->fields['admin_pass'])) {
	      $result['authenticateResult'][1] = 'nvu';
    	  return $result;//Die Not a Valied User
	    }else{
	      $result['authenticateResult'][1] = $settings->companyFile;
	    }
	
	 //Population of the Que  -- Adds new Customers, Orders and Items that have not been processed by this Script successfully.  
	    $qb->setQue();
	    
	  //Log some Data 
	     $db->Execute("INSERT INTO ".QUICKBOOKS_TABLE_SESSIONS." (user,startTime,ticket)VALUES(".$dbresult->fields['admin_id'].",".time().",'".$result['authenticateResult'][0]."')");
	    $qb->logMessage('User Started Session');
	  
	  //Return Session to QWC  
	    return $result;
}
//This is the Last Function QWC Calls
function closeConnection($params){		
	global $db;//Zends Database Object
	global $settings;//Our Settings
	global $qb;//The Quickbooks Object
	
	//Log some Data and End the Session
		$settings->ticket = $params->ticket;
		$qb->logMessage('User Ended Session');
		$db->Execute("UPDATE ".QUICKBOOKS_TABLE_SESSIONS." SET endTime = ".time()." WHERE ticket = '".zen_db_input($params->ticket)."'");
	
	//Return the End Message
	$result['closeConnectionResult'] = 'Thank your for Using the Zen Cart QuickBooks Connector';
	
	return $result;
	
}
//QWC Calls this if there was a Connection Error on the QWC Side
function connectionError($params){
	global $db;//Zends Database Object
	global $settings;//Our Settings
	global $qb;//The Quickbooks Object
	
	//parse and preform very very basic security on returned params
	$ticket 	= zen_db_input($params->ticket);
	$hresult 	= zen_db_input($params->hresult);
	$message 	= zen_db_input($params->message);
	$settings->ticket = $ticket;
	
	//log the Error
	$qb->logError($message);	
	
	$result['connectionErrorResult'] = 'done';
	
	return $result;
	
	
}
//QWC Calls this any time it encouters an error
function getLastError($params){
	global $db;//Zends Database Object
	global $settings;//Our Settings
	global $qb;//The Quickbooks Object
	
	//get the last entry from the log for this session
	$session = $db->Execute("SELECT * FROM ".QUICKBOOKS_TABLE_LOG." WHERE ticket = '".zen_db_input($params->ticket)."' ORDER BY id DESC");
	//build the String	
	$str = $session->fields['action'].': '.$session->fields['message']." \n"; 
	//set the return
  	$result['getLastErrorResult'] = $str;
  	//return the error
  	return $result;
}
//QWC Calls this function when Requesting qbXML from the Server 
function sendRequestXML($params){
	global $db;//Zends Database Object
	global $settings;//Our Settings
	global $qb;//The Quickbooks Object
	
	//Set up and Security Parse the Paramaters	
	$ticket 		= zen_db_input($params->ticket);
	$settings->ticket = $ticket;
	$strHCPResponse = zen_db_input($params->strHCPResponse);
	$strCompanyFile = $params->strCompanyFileName;
	$qbXMLCountry 	= zen_db_input($params->qbXMLCountry);
	$qbXMLMajorVers = zen_db_input($params->qbXMLMajorVers);
	$qbXMLMinorVers = zen_db_input($params->qbXMLMinorVers);
	
	
	//Check if Session is Valid
	$dbSession = $db->Execute("SELECT * FROM ".QUICKBOOKS_TABLE_SESSIONS." WHERE ticket = '".$ticket."' AND endTime = 0");
	if($dbSession->RecordCount() == 0){
		$qb->logError('Session Invaild');		
		$result = "NoOp";
		return $result;
	}
	/*
	//Check that we are working with the Right Company File	
	$fileName = explode('\\',$strCompanyFile);
	$x = count($fileName);
	if($fileName[$x-1] != $settings->companyFileName){
		$qb->logError('Quickbooks is Updating the Wrong Company.  Expecting: '.$settings->companyFileName .' Recieved: '.$strCompanyFile);		
		$result['sendRequestXMLResult'] = $fileName[$x-1].":".$settings->companyFileName;
		return $result;
	}
	*/
	//Select the Next Item in the Que
	$queItem = $db->Execute("SELECT * FROM ".QUICKBOOKS_TABLE_QUE.' WHERE complete = 0 LIMIT 1');
	//Check the Number of Qued Items if 0 return an Empty String Signifiy Completion
	if($queItem->RecordCount() > 0){
		//Choose which funcion to implment
		switch($queItem->fields['action']){
			case 'addCustomer':
				$xml = $qb->addCustomer($queItem->fields['refid']);
				break;
			case 'addItem':
				$xml = $qb->addItem($queItem->fields['refid']);
				break;
			case 'addSalesReciept':
				$xml = $qb->addSalesReciept($queItem->fields['refid']);
				break;
			default:
				$qb->logError('Invalid Operation from the Que');
				$result = "NoOp";
				return $result;
		}
		
	}else{
		
		$xml = "";
	}
	
	//Update the Que to change the Status of the Items we are working with the -1
	$db->Execute("UPDATE ".QUICKBOOKS_TABLE_QUE." SET complete = -1 WHERE id = ".$queItem->fields['id']);
	//Set the Return Variable
	if(QUICKBOOKS_DEBUG){
		$qb->logMessage($xml);
	}
	$result['sendRequestXMLResult'] = $xml; 
	
	//Return the Request
	return $result;
	
}
//QWC Sends back the data or result of the SendRequest function
function receiveResponseXML($params){
	global $db;//Zends Database Object
	global $settings;//Our Settings
	global $qb;//The Quickbooks Object
	
	//Set up the Soap Parameters
	$ticket 			= zen_db_input($params->ticket);
	$settings->ticket   = $ticket;
	$response 			= zen_db_input($params->response);
	$hresult 			= zen_db_input($params->hresult);
	$message			= zen_db_input($params->message);
	
	
	//Check if Session is Valid
	$dbSession = $db->Execute("SELECT * FROM ".QUICKBOOKS_TABLE_SESSIONS." WHERE ticket = '".$ticket."' AND endTime = 0");
	if($dbSession->RecordCount() == 0){
		$qb->logError('Session Invaild');		
		$result['receiveResponseXMLResult'] = -1;
		return $result;
	}
		
	//Get the Active Item from the Que
	$queItem = $db->Execute("SELECT * FROM ".QUICKBOOKS_TABLE_QUE." WHERE complete = -1");

	//check for Error{
	if(!empty($hresult) && !empty($message)){
		$qb->logError($hresult.":".$message);
	}else{
		//log the raw XML response
		if(QUICKBOOKS_DEBUG){
			$qb->logMessage($response);
		}
		//Try to Parse the Response XML
		try{ 
			$xml = new SimpleXMLElement(mb_convert_encoding(str_replace(array("\n","\t",'\\'),'',$response), "UTF-8"));
			$error = false;
		}catch(Exception $e){
			$qb->logError(zen_db_input($response."ERROR:".$e));
			$error = true;
		}
	
		if($error == false){
			//Process the Response from Quickbooks
			switch($queItem->fields['action']){
				case 'addCustomer':
					$qb->addCustomerResponse($xml,$queItem->fields['refid']);
					break;
				case 'addSalesReceipt':
					$qb->addSalesReceiptResponse($xml,$queItem->fields['refid']);
					break;
				case 'addItem':
					$qb->addItemResponse($xml,$queItem->fields['refid']);
				
				}
		}
				
		//delete the processed Item from Que (even if processed unsuccessfully,  it will be readded on next sync)
		$db->Execute("DELETE FROM ".QUICKBOOKS_TABLE_QUE." WHERE id = ".$queItem->fields['id']);
		//update the total count
		$db->Execute("UPDATE ".QUICKBOOKS_TABLE_SESSIONS." SET count= count+1 WHERE ticket = '". $ticket ."'");
		
		$count = $db->Execute("SELECT count(*) as total FROM ".QUICKBOOKS_TABLE_QUE);
		if($count->fields['total'] > 0){
			$result['receiveResponseXMLResult'] = 0;
		}else{
			 $result['receiveResponseXMLResult'] = 100;
		}
	}
		
	
	return $result;
}

//Start the Soap Server
  $server = new SoapServer("http://developer.intuit.com/uploadedFiles/Support/QBWebConnectorSvc.wsdl");
  	$server->addFunction("authenticate");
  	$server->addFunction("sendRequestXML");
  	$server->addFunction("receiveResponseXML");
  	$server->addFunction("getLastError");
  	$server->addFunction("connectionError");
  	$server->addFunction("closeConnection");
  $server->handle(); 
  
  

?>