<?php
//databse tables
//Do not Change Names unless you modified the Install Script
define('QUICKBOOKS_TABLE_LOG','quickbooks_log');//Log Table
define('QUICKBOOKS_TABLE_ERROR','quickbooks_error');//Errors Table
define('QUICKBOOKS_TABLE_SESSIONS','quickbooks_sessions');//Sessions Table
define('QUICKBOOKS_TABLE_QUE','quickbooks_que');//Que Table

//Log Debug Messages -- This will make the log Table Very Large as it will log EVERYTHING
define('QUICKBOOKS_DEBUG',false);

//Settings
$settings = new stdClass();
//$settings->companyFileName	 = "";//Just the File Name of the Company for this Store
$settings->nameFormat		 = '{lastname},{firstname}'; // How should the Customer names be Used in Quickbooks,  Last name first is most common and Defualt
$settings->customerParent	 = 'ambsconservation.com'; // Set this to the Parent Item in Quickbooks for customers of your Web Site,  Leave blank if you do not have a Parent for the Customer List.  Come People Sell on more than 1 site or more than 1 location so the Customers are Seperated 
$settings->orderPending		 = '1';//Set the Status as Pending "0" or Normal "1"
$settings->printOrder		 = '1';//Add to "To be Printed" list "1" for yes "0" for no
$settings->addProducts		 = true;// Add the Products to Quickbooks (only on the First Sync,  Products added after the first Sync will be ignored
$settings->shippingItem		 = 'Shipping and Handling';
$settings->salesTax			 = 'Sales Tax';

//The Following Variables only need to be set if the above variable is "true" 
$settings->IncomeAccount	 = 'Sales';// Income Account for Sales
$settings->COGS				 = 'Cost of Goods Sold';//Cost of Goods Sold Account
$settings->AssestAccount	 = 'Inventory Asset';//Inventory Account
$settings->MarkUp			 = 30;//Markup,  this will set the COST of the item based on your Markup and selling price


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#DO NOT EDIT BELOW THIS LINE
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

/**
 *  Creates and Preforms most of the Work for the qbXML and other Admin Functions
 *
 */

class Quickbooks {
	
	private $db; 
	private $settings;
	
	
	function __construct(){
		
		$this->db 		= $GLOBALS['db']; //grab the ZenCart Database Object
		$this->settings = $GLOBALS['settings']; //grab the Settings Object
	}
	
	/**
	 *   Create the Que for the SOAP Server
	 *
	 */
	function setQue(){
		
		$this->db->Execute("TRUNCATE TABLE ".QUICKBOOKS_TABLE_QUE);
		
		$customers = $this->db->Execute('SELECT customers_id FROM '.TABLE_CUSTOMERS.' WHERE quickbooks = 0 AND customers_id NOT IN (SELECT refid FROM '.QUICKBOOKS_TABLE_QUE.' WHERE action = \'addCustomer\' )');
	
		while (!$customers->EOF){
			$this->db->Execute("INSERT INTO ".QUICKBOOKS_TABLE_QUE."(action,refid)VALUES('addCustomer',".$customers->fields['customers_id'].")");
			$customers->MoveNext();
		}
		
		if($this->settings->addProducts){
			$products = $this->db->Execute('SELECT products_id FROM '.TABLE_PRODUCTS.' WHERE quickbooks = 0 AND products_id NOT IN (SELECT refid FROM '.QUICKBOOKS_TABLE_QUE.' WHERE action = \'addItem\' )');
			
			while (!$products->EOF){
				if($products->fields['quickbooks_salesreceipt'] == 0){
					$this->db->Execute('INSERT INTO '.QUICKBOOKS_TABLE_QUE.'(action,refid)VALUES(\'addItem\','.$products->fields['products_id'].')');
				}
				$products->MoveNext();
				
			}
		}
		
		$orders = $this->db->Execute('SELECT orders_id FROM '.TABLE_ORDERS.' WHERE quickbooks= 0 AND orders_id NOT IN (SELECT refid FROM '.QUICKBOOKS_TABLE_QUE.' WHERE action = \'addSalesReciept\' )');
		
		while (!$orders->EOF){
			if($orders->fields['quickbooks_salesreceipt'] == 0){
				$this->db->Execute('INSERT INTO '.QUICKBOOKS_TABLE_QUE.'(action,refid)VALUES(\'addSalesReciept\','.$orders->fields['orders_id'].')');
			}
			$orders->MoveNext();
			
		}
		
	
	
	
}

	/**
	 * Create the qbXML for the Add Customer Request
	 *
	 * @param int $zenCustID
	 * @return string xml
	 */
	function addCustomer($zenCustID){
		global $settings;
		
		$customer = $this->db->Execute("SELECT * FROM ".TABLE_CUSTOMERS." WHERE customers_id = ".$zenCustID);
		$listName = str_replace(array('{lastname}','{firstname}'),array($customer->fields['customers_lastname'],$customer->fields['customers_firstname']),$settings->nameFormat); 
		$customerAddress = $this->db->Execute("SELECT * FROM ".TABLE_ADDRESS_BOOK." WHERE address_book_id = ".$customer->fields['customers_default_address_id']);
		$country = $this->db->Execute("SELECT countries_iso_code_2 as code FROM ".TABLE_COUNTRIES." WHERE countries_id = ".$customerAddress->fields['entry_country_id']);
		
		$xml = ('<?xml version="1.0" encoding="utf-8"?>
					<?qbxml version="4.0"?>
						<QBXML>
							<QBXMLMsgsRq onError="continueOnError">
								<CustomerAddRq>
									<CustomerAdd> <!-- required -->
										<Name >'.$listName.'</Name> <!-- required -->
				');
		if(!empty($settings->customerParent)){
		 $xml .=('						<ParentRef> <!-- optional -->
												<FullName >'.$settings->customerParent.'</FullName> <!-- optional -->
										</ParentRef>
				');
		}
		$xml .=('						<CompanyName >'.$customerAddress->fields['company'].'</CompanyName> <!-- optional -->
										<FirstName >'.$customer->fields['customers_firstname'].'</FirstName> <!-- optional -->
										<LastName >'.$customer->fields['customers_lastname'].'</LastName> <!-- optional -->
										<BillAddress> <!-- optional -->
											<Addr1 >'.$customer->fields['customers_firstname'].' '.$customer->fields['customers_lastname'].'</Addr1> <!-- optional -->
											<Addr2 >'.$customerAddress->fields['entry_street_address'].'</Addr2> <!-- optional -->
											<Addr3 >'.$customerAddress->fields['entry_suburb'].'</Addr3> <!-- optional -->
											<City >'.$customerAddress->fields['entry_city'].'</City> <!-- optional -->
											<State >'.$customerAddress->fields['entry_state'].'</State> <!-- optional -->
											<PostalCode >'.$customerAddress->fields['entry_postcode'].'</PostalCode> <!-- optional -->
											<Country >'.$country->fields['code'].'</Country> <!-- optional -->
										</BillAddress>
										<ShipAddress> <!-- optional -->
											<Addr1 >'.$customer->fields['customers_firstname'].' '.$customer->fields['customers_lastname'].'</Addr1> <!-- optional -->
											<Addr2 >'.$customerAddress->fields['entry_street_address'].'</Addr2> <!-- optional -->
											<Addr3 >'.$customerAddress->fields['entry_suburb'].'</Addr3> <!-- optional -->
											<City >'.$customerAddress->fields['entry_city'].'</City> <!-- optional -->
											<State >'.$customerAddress->fields['entry_state'].'</State> <!-- optional -->
											<PostalCode >'.$customerAddress->fields['entry_postcode'].'</PostalCode> <!-- optional -->
											<Country >'.$country->fields['code'].'</Country> <!-- optional -->
										</ShipAddress>
										<Phone >'.$customer->fields['customers_telephone'].'</Phone> <!-- optional -->
										<Fax >'.$customer->fields['customers_fax'].'</Fax> <!-- optional -->
										<Email >'.$customer->fields['customers_email_address'].'</Email> <!-- optional -->
									</CustomerAdd>
							  </CustomerAddRq>
						</QBXMLMsgsRq>
					</QBXML>
				');	
	
	
		return  mb_convert_encoding(str_replace(array("\n","\t"),' ',$xml), "UTF-8");
		
		
		
	}

	/**
	 * Process the Response
	 *
	 * @param object $xml
	 * @param int $refid
	 * @return bool
	 */
	function addCustomerResponse($xml,$refid){
		
		$statusCode = (string)$xml->QBXMLMsgsRs->CustomerAddRs->attributes()->statusCode;
		
		if($statusCode == '0' || $statusCode == '3100'){
			$this->db->Execute("UPDATE ".TABLE_CUSTOMERS." SET quickbooks = 1 WHERE customers_id = ".$refid);
			return true;
		}else{
			$this->logError((string)$xml->QBXMLMsgsRs->CustomerAddRs->attributes()->statusMessage);
			return false;
			
		}
		
		
	}
	
	function addSalesReciept($zenOrderID){
		$this->db->Execute("INSERT INTO ".QUICKBOOKS_TABLE_LOG."(time,action,message,ticket)VALUES(".time().",'SENDSR','START','".$ticket."')");
		$order 		= $this->db->Execute("SELECT * FROM ".TABLE_ORDERS." WHERE orders_id = ".$zenOrderID);
		$customer 	= $this->db->Execute("SELECT * FROM ".TABLE_CUSTOMERS." WHERE customers_id = ".$order->fields['customers_id']);
		$listName = str_replace(array('{lastname}','{firstname}'),array($customer->fields['customers_lastname'],$customer->fields['customers_firstname']),$this->settings->nameFormat); 
		$ccInfo		= $this->db->Execute("SELECT * FROM ".TABLE_AUTHORIZENET." WHERE order_id = ".$zenOrderID); 
		$items		= $this->db->Execute("SELECT * FROM ".TABLE_ORDERS_PRODUCTS." WHERE orders_id = ".$zenOrderID);		
		$shipping 	= $this->db->Execute("SELECT * FROM ".TABLE_ORDERS_TOTAL." WHERE orders_id = ".$zenOrderID ." AND class = 'ot_shipping'");
		
		if(!empty($this->settings->customerParent)){
			$fullName = $this->settings->customerParent.':'.$listName;
		}else{
			$fullName = $listName;
		}
		
		$xml = ('<?xml version="1.0" encoding="utf-8"?>
					<?qbxml version="5.0"?>
						<QBXML>
							<QBXMLMsgsRq onError="continueOnError">
								<SalesReceiptAddRq>
									<SalesReceiptAdd> <!-- required -->
										<CustomerRef> <!-- optional -->
											<FullName>'.$fullName.'</FullName> <!-- optional -->
										</CustomerRef>
										<TxnDate >'.date('Y-m-d',strtotime($order->fields['date_purchased'])).'</TxnDate> <!-- optional -->
										<RefNumber >WEB-'.$order->fields['orders_id'].'</RefNumber> <!-- optional -->
										<BillAddress> <!-- optional -->
											<Addr1 >'.$customer->fields['customers_firstname'].' '.$customer->fields['customers_lastname'].'</Addr1> <!-- optional -->
											<Addr2 >'.$order->fields['billing_street_address'].'</Addr2> <!-- optional -->
											<Addr3 >'.$order->fields['billing_suburb'].'</Addr3> <!-- optional -->
											<City >'.$order->fields['billing_city'].'</City> <!-- optional -->
											<State >'.$order->fields['billing_state'].'</State> <!-- optional -->
											<PostalCode >'.$order->fields['billing_postcode'].'</PostalCode> <!-- optional -->
											<Country >'.$order->fields['billing_country'].'</Country> <!-- optional -->
										</BillAddress>
										<ShipAddress> <!-- optional -->
											<Addr1 >'.$customer->fields['customers_firstname'].' '.$customer->fields['customers_lastname'].'</Addr1> <!-- optional -->
											<Addr2 >'.$order->fields['delivery_street_address'].'</Addr2> <!-- optional -->
											<Addr3 >'.$order->fields['delivery_suburb'].'</Addr3> <!-- optional -->
											<City >'.$order->fields['delivery_city'].'</City> <!-- optional -->
											<State >'.$order->fields['delivery_state'].'</State> <!-- optional -->
											<PostalCode >'.$order->fields['delivery_postcode'].'</PostalCode> <!-- optional -->
											<Country >'.$order->fields['delivery_country'].'</Country> <!-- optional -->
										</ShipAddress>
										<IsPending >'.$this->settings->orderPending.'</IsPending> <!-- optional -->
										<IsToBePrinted >'.$this->settings->printOrder.'</IsToBePrinted> <!-- optional -->
						');
		
			while(!$items->EOF){
				$xml .= ('					<SalesReceiptLineAdd> <!-- optional -->
												<ItemRef> <!-- optional -->
													<FullName >'.$items->fields['products_model'].'</FullName> <!-- optional -->
												</ItemRef>
												<Desc >'.$items->fields['products_name'].'</Desc> <!-- optional -->
												<Quantity >'.$items->fields['products_quantity'].'</Quantity> <!-- optional -->
												<Rate >'.$items->fields['final_price'].'</Rate> <!-- optional -->
											</SalesReceiptLineAdd>
							');			
				$items->MoveNext();
			}
			//add a Blank Line
			$xml .= ('						<SalesReceiptLineAdd> <!-- optional -->
												<Desc>------</Desc> <!-- optional -->
											</SalesReceiptLineAdd>
					');
			
			//add shipping
			if($shipping->RecordCount() == 1){
				$xml .= ('					<SalesReceiptLineAdd> <!-- optional -->
												<ItemRef> <!-- optional -->
													<FullName >'.$this->settings->shippingItem.'</FullName> <!-- optional -->
												</ItemRef>
												<Desc >'.strip_tags(str_replace(array('&reg;','(',')',':'),'',$shipping->fields['title'])).'</Desc> <!-- optional -->
												<Quantity >1</Quantity> <!-- optional -->
												<Rate >'.$shipping->fields['value'].'</Rate> <!-- optional -->
											</SalesReceiptLineAdd>
							');			
			}
			
			//add Taxes
			if($order->fields['order_tax'] > 0){
				$xml .= ('					<SalesReceiptLineAdd> <!-- optional -->
												<ItemRef> <!-- optional -->
													<FullName >'.$this->settings->salesTax.'</FullName> <!-- optional -->
												</ItemRef>
												<Desc >Sales Tax</Desc> <!-- optional -->
												<Quantity >1</Quantity> <!-- optional -->
												<Rate >'.$order->fields['tax'].'</Rate> <!-- optional -->
											</SalesReceiptLineAdd>
							');	
			}
			
			
				
			$xml .= ('							</SalesReceiptAdd>
									</SalesReceiptAddRq>
								
							</QBXMLMsgsRq>
						</QBXML>
					');
			
			

			return  mb_convert_encoding(str_replace(array("\n","\t"),' ',$xml), "UTF-8");
	}
		
	function addSalesReceiptResponse($xml,$refid){
		
		$statusCode = (string)$xml->QBXMLMsgsRs->SalesReceiptAddRs->attributes()->statusCode;
		
		if($statusCode == '0' || $statusCode == '3100'){
			$this->db->Execute("UPDATE ".TABLE_ORDERS." SET quickbooks = 1 WHERE orders_id = ".$refid);
			return true;
		}else{
			$this->logError('Error:'.(string)$xml->QBXMLMsgsRs->SalesReceiptAddRs->attributes()->statusMessage);
			return false;
			
		}
	}

	function addItem($refid){
		
		$products = $this->db->Execute('SELECT * FROM '.TABLE_PRODUCTS.' WHERE products_id = '.$refid);
		$pDesc = $this->db->Execute('SELECT * FROM '.TABLE_PRODUCTS_DESCRIPTION.' WHERE products_id = '.$refid);
		$manuf = $this->db->Execute('SELECT * FROM '.TABLE_MANUFACTURERS.' WHERE manufacturers_id = '.$products->fields['manufacturers_id']);
		$xml = ('<?xml version="1.0" encoding="utf-8"?>
					<?qbxml version="5.0"?>
						<QBXML>
							<QBXMLMsgsRq onError="continueOnError">
								<ItemInventoryAddRq>
									<ItemInventoryAdd> <!-- required -->
										<Name >'.$products->fields['products_model'].'</Name> <!-- required -->
										<IsActive >1</IsActive> <!-- optional -->
										<SalesDesc >'.$pDesc->fields['products_name'].'</SalesDesc> <!-- optional -->
										<SalesPrice >'.$products->fields['products_price'].'</SalesPrice> <!-- optional -->
										<IncomeAccountRef>
											<FullName>'.$this->settings->IncomeAccount.'</FullName>
										</IncomeAccountRef>
										<PurchaseDesc >'.$pDesc->fields['products_name'].'</PurchaseDesc> <!-- optional -->
										<PurchaseCost >'.$products->fields['products_price']*((100-$this->sessings->MarkUp)/100).'</PurchaseCost> <!-- optional -->
										<COGSAccountRef> <!-- optional -->
											<FullName >'.$this->settings->COGS.'</FullName> <!-- optional -->
										</COGSAccountRef>
										<PrefVendorRef>
											<FullName>'.$manuf->fields['manufacturers_name'].'</FullName>
										</PrefVendorRef>
										<AssetAccountRef>
											<FullName>'.$this->settings->AssestAccount.'</FullName>
										</AssetAccountRef>
									</ItemInventoryAdd>
								</ItemInventoryAddRq>
							</QBXMLMsgsRq>
						</QBXML>');
		return mb_convert_encoding(str_replace(array("\n","\t"),' ',$xml), "UTF-8");
	}
	
	function addItemResponse($xml,$refid){
		
		$statusCode = (string)$xml->QBXMLMsgsRs->ItemInventoryAddRs->attributes()->statusCode;
		
		if($statusCode == "0" || $statusCode == "3100"){
			$this->db->Execute("UPDATE ".TABLE_PRODUCTS." SET quickbooks = 1 WHERE products_id = ".$refid);
			return true;
		}else{
			$this->logError((string)$xml->QBXMLMsgsRs->ItemInventoryAddRs->attributes()->statusMessage);
			return false;
			
		}
	}
	
	function logMessage($message){
		
		$this->db->Execute("INSERT INTO ".QUICKBOOKS_TABLE_LOG." (time,action,message,ticket)VALUES(".time().",'LOG','".$message."','".$this->settings->ticket."')");
		
	}
	function logError($message){
		
		$this->db->Execute("INSERT INTO ".QUICKBOOKS_TABLE_LOG." (time,action,message,ticket)VALUES(".time().",'ERROR','".$message."','".$this->settings->ticket."')");
		
	}
	
	function viewLog($session){
		
		$log = $this->db->Execute('SELECT * FROM '.QUICKBOOKS_TABLE_LOG .' WHERE ticket = \''.$session.'\' ORDER BY time');
		
				
		echo '<table border ="1">';
		echo '<tr><th>Action</th><th>Message</th><th>Time</th></tr>';
		$x = true;
		
		
		while(!$log->EOF){
			try{
				$message = @new SimpleXMLElement(mb_convert_encoding(str_replace(array("\n","\t",'\\'),'',$log->fields['message']), "UTF-8"));
			}catch (Exception $e){
				$message = $log->fields['message'];
			}

			if($x){
				$css = 'odd';
				$x = false;
			}else{
				$css = 'even';
				$x = true;
			}
			
			
			echo '<tr><td class="'.$css.'">'.
				  $log->fields['action'].
				  '</td><td class="'.$css.'" ><div class="message"><pre>';
				  
			 if (is_object($message))  print_r($message); else  echo $message;
			 
			 echo  '</pre></div></td><td class="'.$css.' ticket">'.$log->fields['ticket'].'<br><span class="date">'.date('m-d-y h:i:s A').'</span></td></tr>';

			$log->MoveNext();
					
		}
		
		echo '</table>';
	}
	
	function viewSessions(){
		
		$log = $this->db->Execute('SELECT * FROM '.QUICKBOOKS_TABLE_SESSIONS .' s LEFT JOIN ' . TABLE_ADMIN .' u ON u.admin_id = s.user ORDER BY startTime');
		
		
		
		echo '<table>';
		echo '<tr><th>User</th><th>Start Time</th><th>End Time</th><th>Requests Processed</th><th>View Log</th></tr>';
		
		$x = true;
		
		
		while(!$log->EOF){
			
			if($x){
				$css = 'odd';
				$x = false;
			}else{
				$css = 'even';
				$x = true;
			}
			
			
			echo '<tr><td class="'.$css.'">'.$log->fields['admin_name'].'</td><td class="'.$css.'">'.date('m/d/Y h i a', $log->fields['startTime']).'</td><td class="'.$css.'">'.date('m/d/Y h i a', $log->fields['endTime']).'</td><td class="'.$css.'">'.$log->fields['count'].'</td><td class="'.$css.'"><a href="'.HTTP_SERVER.DIR_WS_ADMIN.'qbAdmin.php?action=log&session='.$log->fields['ticket'].'">View Log</a></td>';

			$log->MoveNext();
					
		}
		
		echo '</table>';
	}
}
